Bug 64128 - pine mishandles IMAP4 mailbox referrals
pine mishandles IMAP4 mailbox referrals
Status: CLOSED WONTFIX
Product: Red Hat Linux
Classification: Retired
Component: pine (Show other bugs)
8.0
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Mike A. Harris
Ben Levenson
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-04-26 02:08 EDT by James Ralston
Modified: 2007-04-18 12:42 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-01-20 19:31:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to update pine-4.44 to development c-client snapshot (71.19 KB, patch)
2002-04-26 16:46 EDT, James Ralston
no flags Details | Diff
spec file to build pine (now release 1.72.1) using pine-4.44-c-client.patch (19.50 KB, text/plain)
2002-04-26 16:49 EDT, James Ralston
no flags Details

  None (edit)
Description James Ralston 2002-04-26 02:08:32 EDT
Pine has a bug with its handling of IMAP4 mailbox referrals (per RFC2193).
This bug manifests when Pine goes to append the Fcc for a sent message, and
receives the mailbox referral response.  Pine correctly parses the referral,
but then tries to append a zero-length message to the referenced location.

Here's a protocol log that demonstrates the bug.  (I have changed usernames and
server names; otherwise, the output is unmodified.)

While talking to imap.example.com:

>>> 00000016 APPEND INBOX {359}
<<< 00000016 NO [REFERRAL imap://;AUTH=*@imap2.example.com/user.smith] Remote
mailbox.

While talking to imap2.example.com:

<<< * OK imap2.example.com Cyrus IMAP4 v2.1.3-048 server ready
[authentication details omitted]
>>> 00000003 APPEND user.smith {0}
<<< 00000003 NO Message has no header/body separator

This bug is present in pine-4.44-1.72.0 (the latest 7.2 errata).  I have not
tested other versions/releases.

To reproduce this bug, arrange for an IMAP server to return a mailbox referral
when Pine attempts to APPEND the Fcc copy of a sent message.
Comment 1 James Ralston 2002-04-26 02:10:31 EDT
Please note that unless you specifically *don't* want me to do so, I
also plan to take up this issue on the pine-info mailing list.
Comment 2 James Ralston 2002-04-26 16:45:07 EDT
One of the members of Carnegie Mellon's Andrew Systems Group had this to say
about pine's IMAP handling:

> Actually, during development of the Aggregator, we've worked with the pine
> developers to fix this problem, and the copy of pine on andrew should have
> the problem corrected.  (There are actually several issues with pine and the
> aggregator, this is however perhaps the worst).
> 
> I am fairly certain that if you build pine 4.44 against the development
> c-client library, most of the issues go away (including APPEND and
> Referrals), though there is a small patch that needs to be applied to pine
> itself in order to correct some UI issues and performance issues that still
> exist.

So, I rebuilt pine-4.44-1.72.0 using the c-client 2002-04-24 development
snapshot.  Indeed, pine now handles mailbox referrals correctly.

I've attached my pine-4.44-c-client.patch file, and my new pine.spec file.
Please give them a whirl.  (Based on my preliminary testing, they don't seem to
break anything.)

IMO, pine's IMAP defects are severe enough to warrant releasing an errata to
fix them.  (They're not going to get fixed in pine until the current c-client
development branch is moved to production, and the pine developers can release
a new version of pine built against it).
Comment 3 James Ralston 2002-04-26 16:46:47 EDT
Created attachment 55527 [details]
patch to update pine-4.44 to development c-client snapshot
Comment 4 James Ralston 2002-04-26 16:49:51 EDT
Created attachment 55528 [details]
spec file to build pine (now release 1.72.1) using pine-4.44-c-client.patch
Comment 5 Mike A. Harris 2002-04-26 18:08:56 EDT
The attached patch changes a lot more than just the bug it fixes.  There
is no way to ensure quality without a full beta release cycle.  This is
something that will have to wait until the PINE team releases an official
PINE update which fixes the problem, or a very small patch which fixes
just this one problem can be made.

Also, keep in mind that PINE is not true open source, and large modifications
of the source code put things on shaky legal ground, while also making
the modified PINE behave differently from all other vendors code.

Barring blaring security holes, our pine remains as close to upstream as
we can keep it, and defer all bug fixes to them to release official updates
for.

I suspect it wont be long until a new pine release is due.

Comment 6 Mike A. Harris 2002-05-30 01:58:55 EDT
I'm closing this bug as WONTFIX for now, as theres no way I am shipping
pine development code.  pine stable releases are bad enough. pine devel
code is likely to fix one problem and introduce 50 others.

Since it's only reported by one person, and is a rather rare feature,
I don't consider it worthy of a special erratum.  When an official
pine release is out that fixes the problem however, it will appear in
rawhide.
Comment 7 James Ralston 2003-01-20 01:27:09 EST
pine 4.50 and later (c-client 2002a and later, really) fix this problem.

Phoebe (at least the first revision) still contains 4.44, however.

Could you please get your personal development RPMs into Rawhide/Phoebe?  I'd
really like to see 8.1 (or whatever it's called) go out the door with a version
of pine that actually does IMAP properly...
Comment 8 Mike A. Harris 2003-01-20 19:31:57 EST
The issue of including pine 4.5x in the distribution is covered
in bug #78497

If pine 4.5x resolves this issue, then the issue will be resolved in
Red Hat Linux when pine 4.5x or later finally gets included in the
distribution.  This issue is not something that will be backported
by Red Hat to pine 4.44 however, so I am reclosing it as WONTFIX.

Note You need to log in before you can comment on or make changes to this bug.